#include <cmath>
#include "Integral_double.h"

bool 
operator==( const Integral_double& l, const Integral_double& r)
{ return (l.d == r.d); }

Integral_double 
operator+( const Integral_double& l, const Integral_double& r)
{ return Integral_double( l.d + r.d); }

Integral_double 
operator%( const Integral_double& l, const Integral_double& r)
{ 
  double d = l.d/r.d; 
  double h = floor(d);
  return Integral_double( l.d - h*r.d );
}

std::ostream&
operator<<( std::ostream& os, const Integral_double& id)
{ 
  os << id.d;
  return os;
}



Integral_double::Integral_double() {}

Integral_double::Integral_double(double dble) : d(dble) {}

Integral_double&
Integral_double::operator=( const Integral_double& id)
{
  d = id.d;
  return *this;
}

Integral_double& 
Integral_double::operator+=( const Integral_double& id)
{
  d += id.d;
  return *this;
}

