// illustrates operator overloading and friend functions
#ifndef INTEGRAL_DOUBLE_H
#define INTEGRAL_DOUBLE_H
#include <iostream>

class Integral_double
{
  public:
    Integral_double();
    Integral_double( double);

    Integral_double& operator=( const Integral_double& );

    friend bool operator==( const Integral_double&, 
                            const Integral_double& );
    // analogously for !=, <, >, <=, >=
    friend Integral_double operator+( const Integral_double&, 
                                      const Integral_double& );
    // analogously for -, *, / 
    friend Integral_double operator%( const Integral_double&, 
                                      const Integral_double& );

    friend std::ostream& operator<<( std::ostream& os, 
                                     const Integral_double& id);
    // analogously for >>

    Integral_double& operator+=( const Integral_double& );
    // analogously for -=, *=, /=

  private:
    double d;
};

#endif // INTEGRAL_DOUBLE_H
