// final circle classes
#ifndef CIRCLE11_H
#define CIRCLE11_H

#include <cstdlib>
#include <GL/glut.h>
#include "point8.h"
#include "color.h"      // defines class Color

class Circle
{
  public:
    Circle(const Point&  p, const float& r);
    Circle(const Circle&);
    Circle& operator=(const Circle&);
    virtual ~Circle();


    float  radius() const;
    float  area() const;
    float  circumference() const;
    Point  center() const;

    virtual void   draw() const;

  protected:           
    void            new_quadric();
    void            free_quadric();

    Point           P;
    float           rad;
    GLUquadricObj*  quadric;
};

class ColoredCircle : public Circle
{
  public:
    ColoredCircle(const Point&  p, const float& r);
    ColoredCircle(const Point&  p, const float& r, const Color& c);
    ColoredCircle(const ColoredCircle& );
    ColoredCircle& operator=(const ColoredCircle&);
    virtual ~ColoredCircle();
    
    // inherits all members from class Color: data + member functions

    virtual void   draw() const;

  private:
    Color           col;
};
  

#endif // CIRCLE11_H
