#ifndef CIRCLE9_H
#define CIRCLE9_H

#include <cstdlib>
#include <GL/glut.h>
#include "point8.h"
#include "color.h"      // defines class Color

class Circle
{
  public:
    Circle(const Point&  p, const float& r);

    float  radius() const;
    float  area() const;
    float  circumference() const;
    Point  center() const;
    void   draw() const;

    GLUquadricObj*  quadric;
  protected:            // allows access by derived classes
    Point           P;
    float           rad;
};

class ColoredCircle : public Circle          // public inheritance
{
  // Circle is        'base class'
  // ColoredCircle is 'derived class'
  public:
    ColoredCircle(const Point&  p, const float& r);
    ColoredCircle(const Point&  p, const float& r, const Color& c);
    
    // inherits all members from class Color: data + member functions

    void   draw() const;   // hides draw() member function from base class
                           // still accessable as Circle::draw()
  private:
    Color           col;
};
  

#endif // CIRCLE9_H
