#include <cstdlib>
#include <iostream>
#include <GL/glut.h>
#include "point8.h"
#include "circle11.h"
#include "color.h"
#include "openGL_helpers8.h"

using namespace std; 

enum Menu_constants { DRAW = 0, CALLDRAW, CALLVIRTUAL, QUIT };

void draw();
void draw2();
void draw3();

void select_menu (int mode)
{ 
  switch(mode)
  { 
    case DRAW: glutDisplayFunc(draw);
               draw();
               break;
    case CALLDRAW: 
               glutDisplayFunc(draw2);
               draw2();
               break;
    case CALLVIRTUAL: 
               glutDisplayFunc(draw3);
               draw3();
               break;
    case QUIT: exit(EXIT_SUCCESS);
  }
}


float radius;
float x;
float y;

void call_draw_by_value( Circle C)
{ C.draw(); }

void call_draw_by_reference( const Circle& C)
{ C.draw(); }

void draw()
{
  glClear( GL_COLOR_BUFFER_BIT );
  glColor3f( 1.0, 0.0, 0.0);
  Circle C0 = Circle( Point(-0.2, 0.7), 0.1);
  C0.draw();
  ColoredCircle C1 = ColoredCircle( Point(0.3, 0.3), 0.4, Color(0.0, 1.0, 0.0));
  C1.draw();
  glColor3f( 0.0, 0.0, 1.0);
  ColoredCircle C2 = ColoredCircle( Point(-0.3, -0.5), 0.3);
  C2.draw();   // draws white circle
  glutSwapBuffers();
}

void draw2()
{
  glClear( GL_COLOR_BUFFER_BIT );
  glColor3f( 1.0, 0.0, 0.0);
  Circle C0 = Circle( Point(-0.2, 0.7), 0.1);
  call_draw_by_value( C0);
  ColoredCircle C1 = ColoredCircle( Point(0.3, 0.3), 0.4, Color(0.0, 1.0, 0.0));
  call_draw_by_value( C1);
  glColor3f( 0.0, 0.0, 1.0);
  ColoredCircle C2 = ColoredCircle( Point(-0.3, -0.5), 0.3);
  call_draw_by_value( C2);
  glutSwapBuffers();
}

void draw3()
{
  glClear( GL_COLOR_BUFFER_BIT );
  glColor3f( 1.0, 0.0, 0.0);
  Circle C0 = Circle( Point(-0.2, 0.7), 0.1);
  call_draw_by_reference( C0);
  ColoredCircle C1 = ColoredCircle( Point(0.3, 0.3), 0.4, Color(0.0, 1.0, 0.0));
  call_draw_by_reference( C1);
  glColor3f( 0.0, 0.0, 1.0);
  ColoredCircle C2 = ColoredCircle( Point(-0.3, -0.5), 0.3);
  call_draw_by_reference( C2);
  glutSwapBuffers();
}


int
main(int argc, char **argv)
{ 
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
  glutInitWindowSize(500,500);
  glutInitWindowPosition(250,250);
  glutCreateWindow("Colored circles");
  glutDisplayFunc(draw);
  glutReshapeFunc(reshape); 
  glutCreateMenu(select_menu);
  glutAddMenuEntry("C.draw()",DRAW);
  glutAddMenuEntry("call_draw_by_value(C)",CALLDRAW);
  glutAddMenuEntry("call_draw_by_reference(C)",CALLVIRTUAL);
  glutAddMenuEntry("Quit",QUIT);
  glutAttachMenu(GLUT_RIGHT_BUTTON);
  glutMainLoop();

  return EXIT_SUCCESS;
}
